import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.net.*;

public class Scribble extends Applet
{
int last_x, last_y;
Button submit = new Button("Submit");
Button clear = new Button("Clear");
Image offScreenImage = null;
Graphics offScreen = null;
Scrollbar size = new Scrollbar(Scrollbar.HORIZONTAL, 5, 1, 1, 20); 

public void init()
	{
	offScreenImage = createImage(this.getSize().width,this.getSize().height);
	offScreen = offScreenImage.getGraphics();
	offScreen.setColor(Color.white);
	offScreen.fillRect(0,0,this.getSize().width,this.getSize().height);
	
	MouseListener ml = new MyMouseListener(this);
	MouseMotionListener mml = new MyMouseMotionListener(this);
	ActionListener sal = new SActionListener(this);
	ActionListener cal = new CActionListener(this);
	this.addMouseListener(ml);
	this.addMouseMotionListener(mml);
	submit.addActionListener(sal);
	clear.addActionListener(cal);
	this.add(submit);
	this.add(clear);
	this.add(size);
	}

public void paint(Graphics g)
	{
	g.drawImage(offScreenImage, 0, 0, this);
	}
}	

class MyMouseListener extends MouseAdapter
	{
	private Scribble scribble;
	public MyMouseListener(Scribble s)
		{
		scribble = s;
		}
	public void mousePressed(MouseEvent e)
		{
		scribble.last_x = e.getX();
		scribble.last_y = e.getY();
		}
	}

class MyMouseMotionListener extends MouseMotionAdapter
	{
	private Scribble scribble;
	public MyMouseMotionListener(Scribble s)
		{
		scribble = s;
		}
	public void mouseDragged(MouseEvent e)
		{
		Graphics g = scribble.getGraphics();
		int x = e.getX(), y = e.getY();
		scribble.offScreen.setColor(Color.black);
		int size = scribble.size.getValue();
		Line.drawLine(scribble.offScreen, scribble.last_x, scribble.last_y, x, y, size);	
		Line.drawLine(g, scribble.last_x, scribble.last_y, x, y, size);	
		scribble.last_x = x; scribble.last_y = y;
		}

	public void mouseUp(MouseEvent e)
		{
		Graphics g = scribble.getGraphics();
		int x = e.getX(), y = e.getY();
		scribble.offScreen.setColor(Color.black);
		int size = scribble.size.getValue();
		scribble.offScreen.fillOval(x, y, size, size);	
		g.fillOval(x, y, size, size);	
		scribble.last_x = x; scribble.last_y = y;
		}
	}

class SActionListener implements ActionListener
	{
	private Scribble scribble;
	public SActionListener(Scribble s)
		{
		scribble = s;
		}
	public void actionPerformed(ActionEvent e)
		{
		try	{
			scribble.submit.setEnabled(false);
			post.doPOST(new URL("http://www.nott.ac.uk/~psystrj/gg/upload.php3"), "foo", scribble.offScreenImage);
			}
		catch (Exception err)
			{
			System.out.println(err);
			}
		Graphics g = scribble.getGraphics();
		g.setColor(Color.white);
		g.fillRect(0,0,scribble.getSize().width,scribble.getSize().height);	
		g.setColor(Color.black);
		g.setFont(new Font("sansserif", Font.BOLD, 12));
		g.drawString("Data sent",1,(scribble.getSize().height)/2);
		}
	}

class CActionListener implements ActionListener
	{
	private Scribble scribble;
	public CActionListener(Scribble s)
		{
		scribble = s;
		}
	public void actionPerformed(ActionEvent e)
		{
		scribble.offScreen = scribble.offScreenImage.getGraphics();
		scribble.offScreen.setColor(Color.white);
		scribble.offScreen.fillRect(0,0,scribble.getSize().width,scribble.getSize().height);
		Graphics g = scribble.getGraphics();
		scribble.paint(g);
		scribble.submit.setEnabled(true);
		}
	}
